use crate::data::boats_layout::BoatsLayout;
use crate::data::GameRules;

enum MapCellContent {
    Invalid,
    Nothing,
    TouchedBoat,
    Boat,
    FailedStrike,
}

impl MapCellContent {
    fn letter(&self) -> &'static str {
        match self {
            MapCellContent::Invalid => "!",
            MapCellContent::Nothing => " ",
            MapCellContent::TouchedBoat => "T",
            MapCellContent::Boat => "B",
            MapCellContent::FailedStrike => "X",
        }
    }
}

pub struct GameMap {
    rules: GameRules,
    boats_config: BoatsLayout,
}

impl GameMap {
    pub fn new(rules: GameRules, boats_config: BoatsLayout) -> Self {
        Self {
            rules,
            boats_config,
        }
    }

    pub fn get_cell_content(&self, x: usize, y: usize) -> MapCellContent {
        // TODO : improve this
        return MapCellContent::Nothing;
    }

    pub fn print_map(&self) {
        for y in 0..self.rules.map_height {
            for x in 0..self.rules.map_width {
                print!("{} ", self.get_cell_content(x, y).letter());
            }
            println!();
        }
    }
}
